---
title: Create incident notification template
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Incidents
---

# Create incident notification template{% #create-incident-notification-template %}
Copy pageCopied
{% tab title="v2" %}
**Note**: This endpoint is in Preview. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                      |
| ----------------- | --------------------------------------------------------------------------------- |
| ap1.datadoghq.com | POST https://api.ap1.datadoghq.com/api/v2/incidents/config/notification-templates |
| ap2.datadoghq.com | POST https://api.ap2.datadoghq.com/api/v2/incidents/config/notification-templates |
| app.datadoghq.eu  | POST https://api.datadoghq.eu/api/v2/incidents/config/notification-templates      |
| app.ddog-gov.com  | POST https://api.ddog-gov.com/api/v2/incidents/config/notification-templates      |
| us2.ddog-gov.com  | POST https://api.us2.ddog-gov.com/api/v2/incidents/config/notification-templates  |
| app.datadoghq.com | POST https://api.datadoghq.com/api/v2/incidents/config/notification-templates     |
| us3.datadoghq.com | POST https://api.us3.datadoghq.com/api/v2/incidents/config/notification-templates |
| us5.datadoghq.com | POST https://api.us5.datadoghq.com/api/v2/incidents/config/notification-templates |

### Overview

Creates a new notification template. This endpoint requires the `incident_notification_settings_write` permission.

OAuth apps require the `incident_notification_settings_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#incidents) to access this endpoint.



### Request

#### Body Data (required)



{% tab title="Model" %}

| Parent field  | Field                        | Type   | Description                                                                         |
| ------------- | ---------------------------- | ------ | ----------------------------------------------------------------------------------- |
|               | data [*required*]       | object | Notification template data for a create request.                                    |
| data          | attributes [*required*] | object | The attributes for creating a notification template.                                |
| attributes    | category [*required*]   | string | The category of the notification template.                                          |
| attributes    | content [*required*]    | string | The content body of the notification template.                                      |
| attributes    | name [*required*]       | string | The name of the notification template.                                              |
| attributes    | subject [*required*]    | string | The subject line of the notification template.                                      |
| data          | relationships                | object | The definition of `NotificationTemplateCreateDataRelationships` object.             |
| relationships | incident_type                | object | Relationship to an incident type.                                                   |
| incident_type | data [*required*]       | object | Relationship to incident type object.                                               |
| data          | id [*required*]         | string | The incident type's ID.                                                             |
| data          | type [*required*]       | enum   | Incident type resource type. Allowed enum values: `incident_types`                  |
| data          | type [*required*]       | enum   | Notification templates resource type. Allowed enum values: `notification_templates` |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "category": "alert",
      "content": "An incident has been declared.\n\nTitle: Sample Incident Title\nSeverity: SEV-2\nAffected Services: web-service, database-service\nStatus: active\n\nPlease join the incident channel for updates.",
      "name": "Example-Incident",
      "subject": "SEV-2 Incident: Sample Incident Title"
    },
    "relationships": {
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "incident_types"
        }
      }
    },
    "type": "notification_templates"
  }
}
```

{% /tab %}

### Response

{% tab title="201" %}
Created
{% tab title="Model" %}
Response with a notification template.

| Parent field                  | Field                         | Type            | Description                                                                                                                                 |
| ----------------------------- | ----------------------------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------------- |
|                               | data [*required*]        | object          | Notification template data from a response.                                                                                                 |
| data                          | attributes                    | object          | The notification template's attributes.                                                                                                     |
| attributes                    | category [*required*]    | string          | The category of the notification template.                                                                                                  |
| attributes                    | content [*required*]     | string          | The content body of the notification template.                                                                                              |
| attributes                    | created [*required*]     | date-time       | Timestamp when the notification template was created.                                                                                       |
| attributes                    | modified [*required*]    | date-time       | Timestamp when the notification template was last modified.                                                                                 |
| attributes                    | name [*required*]        | string          | The name of the notification template.                                                                                                      |
| attributes                    | subject [*required*]     | string          | The subject line of the notification template.                                                                                              |
| data                          | id [*required*]          | uuid            | The unique identifier of the notification template.                                                                                         |
| data                          | relationships                 | object          | The notification template's resource relationships.                                                                                         |
| relationships                 | created_by_user               | object          | Relationship to user.                                                                                                                       |
| created_by_user               | data [*required*]        | object          | Relationship to user object.                                                                                                                |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                               |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                           |
| relationships                 | incident_type                 | object          | Relationship to an incident type.                                                                                                           |
| incident_type                 | data [*required*]        | object          | Relationship to incident type object.                                                                                                       |
| data                          | id [*required*]          | string          | The incident type's ID.                                                                                                                     |
| data                          | type [*required*]        | enum            | Incident type resource type. Allowed enum values: `incident_types`                                                                          |
| relationships                 | last_modified_by_user         | object          | Relationship to user.                                                                                                                       |
| last_modified_by_user         | data [*required*]        | object          | Relationship to user object.                                                                                                                |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                               |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                           |
| data                          | type [*required*]        | enum            | Notification templates resource type. Allowed enum values: `notification_templates`                                                         |
|                               | included                      | [ <oneOf>] | Related objects that are included in the response.                                                                                          |
| included                      | Option 1                      | object          | User object returned by the API.                                                                                                            |
| Option 1                      | attributes                    | object          | Attributes of user object returned by the API.                                                                                              |
| attributes                    | created_at                    | date-time       | The ISO 8601 timestamp of when the user account was created.                                                                                |
| attributes                    | disabled                      | boolean         | Whether the user account is deactivated. Disabled users cannot log in.                                                                      |
| attributes                    | email                         | string          | The email address of the user, used for login and notifications.                                                                            |
| attributes                    | handle                        | string          | The unique handle (username) of the user, typically matching their email prefix.                                                            |
| attributes                    | icon                          | string          | URL of the user's profile icon, typically a Gravatar URL derived from the email address.                                                    |
| attributes                    | last_login_time               | date-time       | The ISO 8601 timestamp of the user's most recent login, or null if the user has never logged in.                                            |
| attributes                    | mfa_enabled                   | boolean         | Whether multi-factor authentication (MFA) is enabled for the user's account.                                                                |
| attributes                    | modified_at                   | date-time       | The ISO 8601 timestamp of when the user account was last modified.                                                                          |
| attributes                    | name                          | string          | The full display name of the user as shown in the Datadog UI.                                                                               |
| attributes                    | service_account               | boolean         | Whether this is a service account rather than a human user. Service accounts are used for programmatic API access.                          |
| attributes                    | status                        | string          | The current status of the user account (for example, `Active`, `Pending`, or `Disabled`).                                                   |
| attributes                    | title                         | string          | The job title of the user (for example, "Senior Engineer" or "Product Manager").                                                            |
| attributes                    | uuid                          | string          | The globally unique identifier (UUID) of the user.                                                                                          |
| attributes                    | verified                      | boolean         | Whether the user's email address has been verified.                                                                                         |
| Option 1                      | id                            | string          | ID of the user.                                                                                                                             |
| Option 1                      | relationships                 | object          | Relationships of the user object returned by the API.                                                                                       |
| relationships                 | org                           | object          | Relationship to an organization.                                                                                                            |
| org                           | data [*required*]        | object          | Relationship to organization object.                                                                                                        |
| data                          | id [*required*]          | string          | ID of the organization.                                                                                                                     |
| data                          | type [*required*]        | enum            | Organizations resource type. Allowed enum values: `orgs`                                                                                    |
| relationships                 | other_orgs                    | object          | Relationship to organizations.                                                                                                              |
| other_orgs                    | data [*required*]        | [object]        | Relationships to organization objects.                                                                                                      |
| data                          | id [*required*]          | string          | ID of the organization.                                                                                                                     |
| data                          | type [*required*]        | enum            | Organizations resource type. Allowed enum values: `orgs`                                                                                    |
| relationships                 | other_users                   | object          | Relationship to users.                                                                                                                      |
| other_users                   | data [*required*]        | [object]        | Relationships to user objects.                                                                                                              |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                               |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                           |
| relationships                 | roles                         | object          | Relationship to roles.                                                                                                                      |
| roles                         | data                          | [object]        | An array containing type and the unique identifier of a role.                                                                               |
| data                          | id                            | string          | The unique identifier of the role.                                                                                                          |
| data                          | type                          | enum            | Roles type. Allowed enum values: `roles`                                                                                                    |
| Option 1                      | type                          | enum            | Users resource type. Allowed enum values: `users`                                                                                           |
| included                      | Option 2                      | object          | Incident type response data.                                                                                                                |
| Option 2                      | attributes                    | object          | Incident type's attributes.                                                                                                                 |
| attributes                    | createdAt                     | date-time       | Timestamp when the incident type was created.                                                                                               |
| attributes                    | createdBy                     | string          | A unique identifier that represents the user that created the incident type.                                                                |
| attributes                    | description                   | string          | Text that describes the incident type.                                                                                                      |
| attributes                    | is_default                    | boolean         | If true, this incident type will be used as the default incident type if a type is not specified during the creation of incident resources. |
| attributes                    | lastModifiedBy                | string          | A unique identifier that represents the user that last modified the incident type.                                                          |
| attributes                    | modifiedAt                    | date-time       | Timestamp when the incident type was last modified.                                                                                         |
| attributes                    | name [*required*]        | string          | The name of the incident type.                                                                                                              |
| attributes                    | prefix                        | string          | The string that will be prepended to the incident title across the Datadog app.                                                             |
| Option 2                      | id [*required*]          | string          | The incident type's ID.                                                                                                                     |
| Option 2                      | relationships                 | object          | The incident type's resource relationships.                                                                                                 |
| relationships                 | created_by_user               | object          | Relationship to user.                                                                                                                       |
| created_by_user               | data [*required*]        | object          | Relationship to user object.                                                                                                                |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                               |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                           |
| relationships                 | google_meet_configuration     | object          | A reference to a Google Meet Configuration resource.                                                                                        |
| google_meet_configuration     | data [*required*]        | object          | The Google Meet configuration relationship data object.                                                                                     |
| data                          | id [*required*]          | string          | The unique identifier of the Google Meet configuration.                                                                                     |
| data                          | type [*required*]        | string          | The type of the Google Meet configuration.                                                                                                  |
| relationships                 | last_modified_by_user         | object          | Relationship to user.                                                                                                                       |
| last_modified_by_user         | data [*required*]        | object          | Relationship to user object.                                                                                                                |
| data                          | id [*required*]          | string          | A unique identifier that represents the user.                                                                                               |
| data                          | type [*required*]        | enum            | Users resource type. Allowed enum values: `users`                                                                                           |
| relationships                 | microsoft_teams_configuration | object          | A reference to a Microsoft Teams Configuration resource.                                                                                    |
| microsoft_teams_configuration | data [*required*]        | object          | The Microsoft Teams configuration relationship data object.                                                                                 |
| data                          | id [*required*]          | string          | The unique identifier of the Microsoft Teams configuration.                                                                                 |
| data                          | type [*required*]        | string          | The type of the Microsoft Teams configuration.                                                                                              |
| relationships                 | zoom_configuration            | object          | A reference to a Zoom configuration resource.                                                                                               |
| zoom_configuration            | data [*required*]        | object          | The Zoom configuration relationship data object.                                                                                            |
| data                          | id [*required*]          | string          | The unique identifier of the Zoom configuration.                                                                                            |
| data                          | type [*required*]        | string          | The type of the Zoom configuration.                                                                                                         |
| Option 2                      | type [*required*]        | enum            | Incident type resource type. Allowed enum values: `incident_types`                                                                          |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "category": "alert",
      "content": "An incident has been declared.\n\nTitle: {{incident.title}}\nSeverity: {{incident.severity}}\nAffected Services: {{incident.services}}\nStatus: {{incident.state}}\n\nPlease join the incident channel for updates.",
      "created": "2025-01-15T10:30:00Z",
      "modified": "2025-01-15T14:45:00Z",
      "name": "Incident Alert Template",
      "subject": "{{incident.severity}} Incident: {{incident.title}}"
    },
    "id": "00000000-0000-0000-0000-000000000001",
    "relationships": {
      "created_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      },
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "incident_types"
        }
      },
      "last_modified_by_user": {
        "data": {
          "id": "00000000-0000-0000-2345-000000000000",
          "type": "users"
        }
      }
    },
    "type": "notification_templates"
  },
  "included": [
    {
      "attributes": {
        "created_at": "2019-09-19T10:00:00.000Z",
        "disabled": false,
        "email": "string",
        "handle": "string",
        "icon": "string",
        "last_login_time": "2019-09-19T10:00:00.000Z",
        "mfa_enabled": false,
        "modified_at": "2019-09-19T10:00:00.000Z",
        "name": "string",
        "service_account": false,
        "status": "string",
        "title": "string",
        "uuid": "string",
        "verified": false
      },
      "id": "string",
      "relationships": {
        "org": {
          "data": {
            "id": "00000000-0000-beef-0000-000000000000",
            "type": "orgs"
          }
        },
        "other_orgs": {
          "data": [
            {
              "id": "00000000-0000-beef-0000-000000000000",
              "type": "orgs"
            }
          ]
        },
        "other_users": {
          "data": [
            {
              "id": "00000000-0000-0000-2345-000000000000",
              "type": "users"
            }
          ]
        },
        "roles": {
          "data": [
            {
              "id": "3653d3c6-0c75-11ea-ad28-fb5701eabc7d",
              "type": "roles"
            }
          ]
        }
      },
      "type": "users"
    }
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                          \## default
# 
 \# Curl command curl -X POST "https://api.datadoghq.com/api/v2/incidents/config/notification-templates" \
-H "Accept: application/json" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "category": "alert",
      "content": "An incident has been declared.\n\nTitle: {{incident.title}}\nSeverity: {{incident.severity}}\nAffected Services: {{incident.services}}\nStatus: {{incident.state}}\n\nPlease join the incident channel for updates.",
      "name": "Incident Alert Template",
      "subject": "{{incident.severity}} Incident: {{incident.title}}"
    },
    "relationships": {
      "incident_type": {
        "data": {
          "id": "00000000-0000-0000-0000-000000000000",
          "type": "incident_types"
        }
      }
    },
    "type": "notification_templates"
  }
}
EOF 
                        
##### 

```go
// Create incident notification template returns "Created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	// there is a valid "incident_type" in the system
	IncidentTypeDataID := os.Getenv("INCIDENT_TYPE_DATA_ID")

	body := datadogV2.CreateIncidentNotificationTemplateRequest{
		Data: datadogV2.IncidentNotificationTemplateCreateData{
			Attributes: datadogV2.IncidentNotificationTemplateCreateAttributes{
				Category: "alert",
				Content: `An incident has been declared.

Title: Sample Incident Title
Severity: SEV-2
Affected Services: web-service, database-service
Status: active

Please join the incident channel for updates.`,
				Name:    "Example-Incident",
				Subject: "SEV-2 Incident: Sample Incident Title",
			},
			Relationships: &datadogV2.IncidentNotificationTemplateCreateDataRelationships{
				IncidentType: &datadogV2.RelationshipToIncidentType{
					Data: datadogV2.RelationshipToIncidentTypeData{
						Id:   IncidentTypeDataID,
						Type: datadogV2.INCIDENTTYPETYPE_INCIDENT_TYPES,
					},
				},
			},
			Type: datadogV2.INCIDENTNOTIFICATIONTEMPLATETYPE_NOTIFICATION_TEMPLATES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateIncidentNotificationTemplate", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewIncidentsApi(apiClient)
	resp, r, err := api.CreateIncidentNotificationTemplate(ctx, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `IncidentsApi.CreateIncidentNotificationTemplate`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `IncidentsApi.CreateIncidentNotificationTemplate`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Create incident notification template returns "Created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.IncidentsApi;
import com.datadog.api.client.v2.model.CreateIncidentNotificationTemplateRequest;
import com.datadog.api.client.v2.model.IncidentNotificationTemplate;
import com.datadog.api.client.v2.model.IncidentNotificationTemplateCreateAttributes;
import com.datadog.api.client.v2.model.IncidentNotificationTemplateCreateData;
import com.datadog.api.client.v2.model.IncidentNotificationTemplateCreateDataRelationships;
import com.datadog.api.client.v2.model.IncidentNotificationTemplateType;
import com.datadog.api.client.v2.model.IncidentTypeType;
import com.datadog.api.client.v2.model.RelationshipToIncidentType;
import com.datadog.api.client.v2.model.RelationshipToIncidentTypeData;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createIncidentNotificationTemplate", true);
    IncidentsApi apiInstance = new IncidentsApi(defaultClient);

    // there is a valid "incident_type" in the system
    String INCIDENT_TYPE_DATA_ID = System.getenv("INCIDENT_TYPE_DATA_ID");

    CreateIncidentNotificationTemplateRequest body =
        new CreateIncidentNotificationTemplateRequest()
            .data(
                new IncidentNotificationTemplateCreateData()
                    .attributes(
                        new IncidentNotificationTemplateCreateAttributes()
                            .category("alert")
                            .content(
                                """
An incident has been declared.

Title: Sample Incident Title
Severity: SEV-2
Affected Services: web-service, database-service
Status: active

Please join the incident channel for updates.
""")
                            .name("Example-Incident")
                            .subject("SEV-2 Incident: Sample Incident Title"))
                    .relationships(
                        new IncidentNotificationTemplateCreateDataRelationships()
                            .incidentType(
                                new RelationshipToIncidentType()
                                    .data(
                                        new RelationshipToIncidentTypeData()
                                            .id(INCIDENT_TYPE_DATA_ID)
                                            .type(IncidentTypeType.INCIDENT_TYPES))))
                    .type(IncidentNotificationTemplateType.NOTIFICATION_TEMPLATES));

    try {
      IncidentNotificationTemplate result = apiInstance.createIncidentNotificationTemplate(body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling IncidentsApi#createIncidentNotificationTemplate");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```python
"""
Create incident notification template returns "Created" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.incidents_api import IncidentsApi
from datadog_api_client.v2.model.create_incident_notification_template_request import (
    CreateIncidentNotificationTemplateRequest,
)
from datadog_api_client.v2.model.incident_notification_template_create_attributes import (
    IncidentNotificationTemplateCreateAttributes,
)
from datadog_api_client.v2.model.incident_notification_template_create_data import (
    IncidentNotificationTemplateCreateData,
)
from datadog_api_client.v2.model.incident_notification_template_create_data_relationships import (
    IncidentNotificationTemplateCreateDataRelationships,
)
from datadog_api_client.v2.model.incident_notification_template_type import IncidentNotificationTemplateType
from datadog_api_client.v2.model.incident_type_type import IncidentTypeType
from datadog_api_client.v2.model.relationship_to_incident_type import RelationshipToIncidentType
from datadog_api_client.v2.model.relationship_to_incident_type_data import RelationshipToIncidentTypeData

# there is a valid "incident_type" in the system
INCIDENT_TYPE_DATA_ID = environ["INCIDENT_TYPE_DATA_ID"]

body = CreateIncidentNotificationTemplateRequest(
    data=IncidentNotificationTemplateCreateData(
        attributes=IncidentNotificationTemplateCreateAttributes(
            category="alert",
            content="An incident has been declared.\n\nTitle: Sample Incident Title\nSeverity: SEV-2\nAffected Services: web-service, database-service\nStatus: active\n\nPlease join the incident channel for updates.",
            name="Example-Incident",
            subject="SEV-2 Incident: Sample Incident Title",
        ),
        relationships=IncidentNotificationTemplateCreateDataRelationships(
            incident_type=RelationshipToIncidentType(
                data=RelationshipToIncidentTypeData(
                    id=INCIDENT_TYPE_DATA_ID,
                    type=IncidentTypeType.INCIDENT_TYPES,
                ),
            ),
        ),
        type=IncidentNotificationTemplateType.NOTIFICATION_TEMPLATES,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_incident_notification_template"] = True
with ApiClient(configuration) as api_client:
    api_instance = IncidentsApi(api_client)
    response = api_instance.create_incident_notification_template(body=body)

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Create incident notification template returns "Created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_incident_notification_template".to_sym] = true
end
api_instance = DatadogAPIClient::V2::IncidentsAPI.new

# there is a valid "incident_type" in the system
INCIDENT_TYPE_DATA_ID = ENV["INCIDENT_TYPE_DATA_ID"]

body = DatadogAPIClient::V2::CreateIncidentNotificationTemplateRequest.new({
  data: DatadogAPIClient::V2::IncidentNotificationTemplateCreateData.new({
    attributes: DatadogAPIClient::V2::IncidentNotificationTemplateCreateAttributes.new({
      category: "alert",
      content: 'An incident has been declared.\n\nTitle: Sample Incident Title\nSeverity: SEV-2\nAffected Services: web-service, database-service\nStatus: active\n\nPlease join the incident channel for updates.',
      name: "Example-Incident",
      subject: "SEV-2 Incident: Sample Incident Title",
    }),
    relationships: DatadogAPIClient::V2::IncidentNotificationTemplateCreateDataRelationships.new({
      incident_type: DatadogAPIClient::V2::RelationshipToIncidentType.new({
        data: DatadogAPIClient::V2::RelationshipToIncidentTypeData.new({
          id: INCIDENT_TYPE_DATA_ID,
          type: DatadogAPIClient::V2::IncidentTypeType::INCIDENT_TYPES,
        }),
      }),
    }),
    type: DatadogAPIClient::V2::IncidentNotificationTemplateType::NOTIFICATION_TEMPLATES,
  }),
})
p api_instance.create_incident_notification_template(body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```rust
// Create incident notification template returns "Created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_incidents::IncidentsAPI;
use datadog_api_client::datadogV2::model::CreateIncidentNotificationTemplateRequest;
use datadog_api_client::datadogV2::model::IncidentNotificationTemplateCreateAttributes;
use datadog_api_client::datadogV2::model::IncidentNotificationTemplateCreateData;
use datadog_api_client::datadogV2::model::IncidentNotificationTemplateCreateDataRelationships;
use datadog_api_client::datadogV2::model::IncidentNotificationTemplateType;
use datadog_api_client::datadogV2::model::IncidentTypeType;
use datadog_api_client::datadogV2::model::RelationshipToIncidentType;
use datadog_api_client::datadogV2::model::RelationshipToIncidentTypeData;

#[tokio::main]
async fn main() {
    // there is a valid "incident_type" in the system
    let incident_type_data_id = std::env::var("INCIDENT_TYPE_DATA_ID").unwrap();
    let body = CreateIncidentNotificationTemplateRequest::new(
        IncidentNotificationTemplateCreateData::new(
            IncidentNotificationTemplateCreateAttributes::new(
                "alert".to_string(),
                r#"An incident has been declared.

Title: Sample Incident Title
Severity: SEV-2
Affected Services: web-service, database-service
Status: active

Please join the incident channel for updates."#
                    .to_string(),
                "Example-Incident".to_string(),
                "SEV-2 Incident: Sample Incident Title".to_string(),
            ),
            IncidentNotificationTemplateType::NOTIFICATION_TEMPLATES,
        )
        .relationships(
            IncidentNotificationTemplateCreateDataRelationships::new().incident_type(
                RelationshipToIncidentType::new(RelationshipToIncidentTypeData::new(
                    incident_type_data_id.clone(),
                    IncidentTypeType::INCIDENT_TYPES,
                )),
            ),
        ),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateIncidentNotificationTemplate", true);
    let api = IncidentsAPI::with_config(configuration);
    let resp = api.create_incident_notification_template(body).await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Create incident notification template returns "Created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createIncidentNotificationTemplate"] =
  true;
const apiInstance = new v2.IncidentsApi(configuration);

// there is a valid "incident_type" in the system
const INCIDENT_TYPE_DATA_ID = process.env.INCIDENT_TYPE_DATA_ID as string;

const params: v2.IncidentsApiCreateIncidentNotificationTemplateRequest = {
  body: {
    data: {
      attributes: {
        category: "alert",
        content:
          "An incident has been declared.\n\nTitle: Sample Incident Title\nSeverity: SEV-2\nAffected Services: web-service, database-service\nStatus: active\n\nPlease join the incident channel for updates.",
        name: "Example-Incident",
        subject: "SEV-2 Incident: Sample Incident Title",
      },
      relationships: {
        incidentType: {
          data: {
            id: INCIDENT_TYPE_DATA_ID,
            type: "incident_types",
          },
        },
      },
      type: "notification_templates",
    },
  },
};

apiInstance
  .createIncidentNotificationTemplate(params)
  .then((data: v2.IncidentNotificationTemplate) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
